import { sha256 } from 'hash.js';
import ApiHttp from 'applets-request-mode-list';

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}

function responseFormatter(res) {
    var data = res && res.data ? res.data : {};
    var code = data.code;
    data.status = res.status;
    if (code !== 200) {
        return Promise.reject(data);
    }
    return data;
}

function errorLog(err) {
    try {
        return {
            v3: "ApiError",
            msg: "接口异常",
            request: err,
        };
    }
    catch (e) {
        console.error(e);
        return {
            v3: "ApiError",
            msg: "catch",
            request: e,
        };
    }
}

var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

/**
 * lodash (Custom Build) <https://lodash.com/>
 * Build: `lodash modularize exports="npm" -o ./`
 * Copyright jQuery Foundation and other contributors <https://jquery.org/>
 * Released under MIT license <https://lodash.com/license>
 * Based on Underscore.js 1.8.3 <http://underscorejs.org/LICENSE>
 * Copyright Jeremy Ashkenas, DocumentCloud and Investigative Reporters & Editors
 */

/** Used as the `TypeError` message for "Functions" methods. */
var FUNC_ERROR_TEXT = 'Expected a function';

/** Used to stand-in for `undefined` hash values. */
var HASH_UNDEFINED = '__lodash_hash_undefined__';

/** Used as references for various `Number` constants. */
var INFINITY = 1 / 0;

/** `Object#toString` result references. */
var funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]',
    symbolTag = '[object Symbol]';

/** Used to match property names within property paths. */
var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
    reIsPlainProp = /^\w*$/,
    reLeadingDot = /^\./,
    rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;

/**
 * Used to match `RegExp`
 * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
 */
var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;

/** Used to match backslashes in property paths. */
var reEscapeChar = /\\(\\)?/g;

/** Used to detect host constructors (Safari). */
var reIsHostCtor = /^\[object .+?Constructor\]$/;

/** Detect free variable `global` from Node.js. */
var freeGlobal = typeof commonjsGlobal == 'object' && commonjsGlobal && commonjsGlobal.Object === Object && commonjsGlobal;

/** Detect free variable `self`. */
var freeSelf = typeof self == 'object' && self && self.Object === Object && self;

/** Used as a reference to the global object. */
var root = freeGlobal || freeSelf || Function('return this')();

/**
 * Gets the value at `key` of `object`.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {string} key The key of the property to get.
 * @returns {*} Returns the property value.
 */
function getValue(object, key) {
  return object == null ? undefined : object[key];
}

/**
 * Checks if `value` is a host object in IE < 9.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a host object, else `false`.
 */
function isHostObject(value) {
  // Many host objects are `Object` objects that can coerce to strings
  // despite having improperly defined `toString` methods.
  var result = false;
  if (value != null && typeof value.toString != 'function') {
    try {
      result = !!(value + '');
    } catch (e) {}
  }
  return result;
}

/** Used for built-in method references. */
var arrayProto = Array.prototype,
    funcProto = Function.prototype,
    objectProto = Object.prototype;

/** Used to detect overreaching core-js shims. */
var coreJsData = root['__core-js_shared__'];

/** Used to detect methods masquerading as native. */
var maskSrcKey = (function() {
  var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
  return uid ? ('Symbol(src)_1.' + uid) : '';
}());

/** Used to resolve the decompiled source of functions. */
var funcToString = funcProto.toString;

/** Used to check objects for own properties. */
var hasOwnProperty = objectProto.hasOwnProperty;

/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */
var objectToString = objectProto.toString;

/** Used to detect if a method is native. */
var reIsNative = RegExp('^' +
  funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\$&')
  .replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$'
);

/** Built-in value references. */
var Symbol$1 = root.Symbol,
    splice = arrayProto.splice;

/* Built-in method references that are verified to be native. */
var Map = getNative(root, 'Map'),
    nativeCreate = getNative(Object, 'create');

/** Used to convert symbols to primitives and strings. */
var symbolProto = Symbol$1 ? Symbol$1.prototype : undefined,
    symbolToString = symbolProto ? symbolProto.toString : undefined;

/**
 * Creates a hash object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function Hash(entries) {
  var index = -1,
      length = entries ? entries.length : 0;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

/**
 * Removes all key-value entries from the hash.
 *
 * @private
 * @name clear
 * @memberOf Hash
 */
function hashClear() {
  this.__data__ = nativeCreate ? nativeCreate(null) : {};
}

/**
 * Removes `key` and its value from the hash.
 *
 * @private
 * @name delete
 * @memberOf Hash
 * @param {Object} hash The hash to modify.
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function hashDelete(key) {
  return this.has(key) && delete this.__data__[key];
}

/**
 * Gets the hash value for `key`.
 *
 * @private
 * @name get
 * @memberOf Hash
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function hashGet(key) {
  var data = this.__data__;
  if (nativeCreate) {
    var result = data[key];
    return result === HASH_UNDEFINED ? undefined : result;
  }
  return hasOwnProperty.call(data, key) ? data[key] : undefined;
}

/**
 * Checks if a hash value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Hash
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function hashHas(key) {
  var data = this.__data__;
  return nativeCreate ? data[key] !== undefined : hasOwnProperty.call(data, key);
}

/**
 * Sets the hash `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Hash
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the hash instance.
 */
function hashSet(key, value) {
  var data = this.__data__;
  data[key] = (nativeCreate && value === undefined) ? HASH_UNDEFINED : value;
  return this;
}

// Add methods to `Hash`.
Hash.prototype.clear = hashClear;
Hash.prototype['delete'] = hashDelete;
Hash.prototype.get = hashGet;
Hash.prototype.has = hashHas;
Hash.prototype.set = hashSet;

/**
 * Creates an list cache object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function ListCache(entries) {
  var index = -1,
      length = entries ? entries.length : 0;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

/**
 * Removes all key-value entries from the list cache.
 *
 * @private
 * @name clear
 * @memberOf ListCache
 */
function listCacheClear() {
  this.__data__ = [];
}

/**
 * Removes `key` and its value from the list cache.
 *
 * @private
 * @name delete
 * @memberOf ListCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function listCacheDelete(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    return false;
  }
  var lastIndex = data.length - 1;
  if (index == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index, 1);
  }
  return true;
}

/**
 * Gets the list cache value for `key`.
 *
 * @private
 * @name get
 * @memberOf ListCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function listCacheGet(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  return index < 0 ? undefined : data[index][1];
}

/**
 * Checks if a list cache value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf ListCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function listCacheHas(key) {
  return assocIndexOf(this.__data__, key) > -1;
}

/**
 * Sets the list cache `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf ListCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the list cache instance.
 */
function listCacheSet(key, value) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }
  return this;
}

// Add methods to `ListCache`.
ListCache.prototype.clear = listCacheClear;
ListCache.prototype['delete'] = listCacheDelete;
ListCache.prototype.get = listCacheGet;
ListCache.prototype.has = listCacheHas;
ListCache.prototype.set = listCacheSet;

/**
 * Creates a map cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */
function MapCache(entries) {
  var index = -1,
      length = entries ? entries.length : 0;

  this.clear();
  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}

/**
 * Removes all key-value entries from the map.
 *
 * @private
 * @name clear
 * @memberOf MapCache
 */
function mapCacheClear() {
  this.__data__ = {
    'hash': new Hash,
    'map': new (Map || ListCache),
    'string': new Hash
  };
}

/**
 * Removes `key` and its value from the map.
 *
 * @private
 * @name delete
 * @memberOf MapCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */
function mapCacheDelete(key) {
  return getMapData(this, key)['delete'](key);
}

/**
 * Gets the map value for `key`.
 *
 * @private
 * @name get
 * @memberOf MapCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */
function mapCacheGet(key) {
  return getMapData(this, key).get(key);
}

/**
 * Checks if a map value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf MapCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */
function mapCacheHas(key) {
  return getMapData(this, key).has(key);
}

/**
 * Sets the map `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf MapCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the map cache instance.
 */
function mapCacheSet(key, value) {
  getMapData(this, key).set(key, value);
  return this;
}

// Add methods to `MapCache`.
MapCache.prototype.clear = mapCacheClear;
MapCache.prototype['delete'] = mapCacheDelete;
MapCache.prototype.get = mapCacheGet;
MapCache.prototype.has = mapCacheHas;
MapCache.prototype.set = mapCacheSet;

/**
 * Gets the index at which the `key` is found in `array` of key-value pairs.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} key The key to search for.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */
function assocIndexOf(array, key) {
  var length = array.length;
  while (length--) {
    if (eq(array[length][0], key)) {
      return length;
    }
  }
  return -1;
}

/**
 * The base implementation of `_.get` without support for default values.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @returns {*} Returns the resolved value.
 */
function baseGet(object, path) {
  path = isKey(path, object) ? [path] : castPath(path);

  var index = 0,
      length = path.length;

  while (object != null && index < length) {
    object = object[toKey(path[index++])];
  }
  return (index && index == length) ? object : undefined;
}

/**
 * The base implementation of `_.isNative` without bad shim checks.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a native function,
 *  else `false`.
 */
function baseIsNative(value) {
  if (!isObject(value) || isMasked(value)) {
    return false;
  }
  var pattern = (isFunction(value) || isHostObject(value)) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource(value));
}

/**
 * The base implementation of `_.toString` which doesn't convert nullish
 * values to empty strings.
 *
 * @private
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 */
function baseToString(value) {
  // Exit early for strings to avoid a performance hit in some environments.
  if (typeof value == 'string') {
    return value;
  }
  if (isSymbol(value)) {
    return symbolToString ? symbolToString.call(value) : '';
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}

/**
 * Casts `value` to a path array if it's not one.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {Array} Returns the cast property path array.
 */
function castPath(value) {
  return isArray(value) ? value : stringToPath(value);
}

/**
 * Gets the data for `map`.
 *
 * @private
 * @param {Object} map The map to query.
 * @param {string} key The reference key.
 * @returns {*} Returns the map data.
 */
function getMapData(map, key) {
  var data = map.__data__;
  return isKeyable(key)
    ? data[typeof key == 'string' ? 'string' : 'hash']
    : data.map;
}

/**
 * Gets the native function at `key` of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {string} key The key of the method to get.
 * @returns {*} Returns the function if it's native, else `undefined`.
 */
function getNative(object, key) {
  var value = getValue(object, key);
  return baseIsNative(value) ? value : undefined;
}

/**
 * Checks if `value` is a property name and not a property path.
 *
 * @private
 * @param {*} value The value to check.
 * @param {Object} [object] The object to query keys on.
 * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
 */
function isKey(value, object) {
  if (isArray(value)) {
    return false;
  }
  var type = typeof value;
  if (type == 'number' || type == 'symbol' || type == 'boolean' ||
      value == null || isSymbol(value)) {
    return true;
  }
  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) ||
    (object != null && value in Object(object));
}

/**
 * Checks if `value` is suitable for use as unique object key.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
 */
function isKeyable(value) {
  var type = typeof value;
  return (type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean')
    ? (value !== '__proto__')
    : (value === null);
}

/**
 * Checks if `func` has its source masked.
 *
 * @private
 * @param {Function} func The function to check.
 * @returns {boolean} Returns `true` if `func` is masked, else `false`.
 */
function isMasked(func) {
  return !!maskSrcKey && (maskSrcKey in func);
}

/**
 * Converts `string` to a property path array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the property path array.
 */
var stringToPath = memoize(function(string) {
  string = toString(string);

  var result = [];
  if (reLeadingDot.test(string)) {
    result.push('');
  }
  string.replace(rePropName, function(match, number, quote, string) {
    result.push(quote ? string.replace(reEscapeChar, '$1') : (number || match));
  });
  return result;
});

/**
 * Converts `value` to a string key if it's not a string or symbol.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {string|symbol} Returns the key.
 */
function toKey(value) {
  if (typeof value == 'string' || isSymbol(value)) {
    return value;
  }
  var result = (value + '');
  return (result == '0' && (1 / value) == -INFINITY) ? '-0' : result;
}

/**
 * Converts `func` to its source code.
 *
 * @private
 * @param {Function} func The function to process.
 * @returns {string} Returns the source code.
 */
function toSource(func) {
  if (func != null) {
    try {
      return funcToString.call(func);
    } catch (e) {}
    try {
      return (func + '');
    } catch (e) {}
  }
  return '';
}

/**
 * Creates a function that memoizes the result of `func`. If `resolver` is
 * provided, it determines the cache key for storing the result based on the
 * arguments provided to the memoized function. By default, the first argument
 * provided to the memoized function is used as the map cache key. The `func`
 * is invoked with the `this` binding of the memoized function.
 *
 * **Note:** The cache is exposed as the `cache` property on the memoized
 * function. Its creation may be customized by replacing the `_.memoize.Cache`
 * constructor with one whose instances implement the
 * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
 * method interface of `delete`, `get`, `has`, and `set`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to have its output memoized.
 * @param {Function} [resolver] The function to resolve the cache key.
 * @returns {Function} Returns the new memoized function.
 * @example
 *
 * var object = { 'a': 1, 'b': 2 };
 * var other = { 'c': 3, 'd': 4 };
 *
 * var values = _.memoize(_.values);
 * values(object);
 * // => [1, 2]
 *
 * values(other);
 * // => [3, 4]
 *
 * object.a = 2;
 * values(object);
 * // => [1, 2]
 *
 * // Modify the result cache.
 * values.cache.set(object, ['a', 'b']);
 * values(object);
 * // => ['a', 'b']
 *
 * // Replace `_.memoize.Cache`.
 * _.memoize.Cache = WeakMap;
 */
function memoize(func, resolver) {
  if (typeof func != 'function' || (resolver && typeof resolver != 'function')) {
    throw new TypeError(FUNC_ERROR_TEXT);
  }
  var memoized = function() {
    var args = arguments,
        key = resolver ? resolver.apply(this, args) : args[0],
        cache = memoized.cache;

    if (cache.has(key)) {
      return cache.get(key);
    }
    var result = func.apply(this, args);
    memoized.cache = cache.set(key, result);
    return result;
  };
  memoized.cache = new (memoize.Cache || MapCache);
  return memoized;
}

// Assign cache to `_.memoize`.
memoize.Cache = MapCache;

/**
 * Performs a
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * comparison between two values to determine if they are equivalent.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.eq(object, object);
 * // => true
 *
 * _.eq(object, other);
 * // => false
 *
 * _.eq('a', 'a');
 * // => true
 *
 * _.eq('a', Object('a'));
 * // => false
 *
 * _.eq(NaN, NaN);
 * // => true
 */
function eq(value, other) {
  return value === other || (value !== value && other !== other);
}

/**
 * Checks if `value` is classified as an `Array` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array, else `false`.
 * @example
 *
 * _.isArray([1, 2, 3]);
 * // => true
 *
 * _.isArray(document.body.children);
 * // => false
 *
 * _.isArray('abc');
 * // => false
 *
 * _.isArray(_.noop);
 * // => false
 */
var isArray = Array.isArray;

/**
 * Checks if `value` is classified as a `Function` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
 * @example
 *
 * _.isFunction(_);
 * // => true
 *
 * _.isFunction(/abc/);
 * // => false
 */
function isFunction(value) {
  // The use of `Object#toString` avoids issues with the `typeof` operator
  // in Safari 8-9 which returns 'object' for typed array and other constructors.
  var tag = isObject(value) ? objectToString.call(value) : '';
  return tag == funcTag || tag == genTag;
}

/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */
function isObject(value) {
  var type = typeof value;
  return !!value && (type == 'object' || type == 'function');
}

/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */
function isObjectLike(value) {
  return !!value && typeof value == 'object';
}

/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */
function isSymbol(value) {
  return typeof value == 'symbol' ||
    (isObjectLike(value) && objectToString.call(value) == symbolTag);
}

/**
 * Converts `value` to a string. An empty string is returned for `null`
 * and `undefined` values. The sign of `-0` is preserved.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 * @example
 *
 * _.toString(null);
 * // => ''
 *
 * _.toString(-0);
 * // => '-0'
 *
 * _.toString([1, 2, 3]);
 * // => '1,2,3'
 */
function toString(value) {
  return value == null ? '' : baseToString(value);
}

/**
 * Gets the value at `path` of `object`. If the resolved value is
 * `undefined`, the `defaultValue` is returned in its place.
 *
 * @static
 * @memberOf _
 * @since 3.7.0
 * @category Object
 * @param {Object} object The object to query.
 * @param {Array|string} path The path of the property to get.
 * @param {*} [defaultValue] The value returned for `undefined` resolved values.
 * @returns {*} Returns the resolved value.
 * @example
 *
 * var object = { 'a': [{ 'b': { 'c': 3 } }] };
 *
 * _.get(object, 'a[0].b.c');
 * // => 3
 *
 * _.get(object, ['a', '0', 'b', 'c']);
 * // => 3
 *
 * _.get(object, 'a.b.c', 'default');
 * // => 'default'
 */
function get(object, path, defaultValue) {
  var result = object == null ? undefined : baseGet(object, path);
  return result === undefined ? defaultValue : result;
}

var lodash_get = get;

/**
 * 组装接口响应日志
 * @param res
 * @returns
 */
function getDataLog(res) {
    var config = lodash_get(res, "config", {});
    var apiConfig = lodash_get(res, "config.apiConfig", {});
    var apiLogConfig = lodash_get(res, "config.apiConfig.log", true);
    var data = lodash_get(res, "data.data", "empty");
    var msg = lodash_get(res, "data.msg", "");
    var code = lodash_get(res, "data.code", -1);
    var request = {
        url: apiConfig.apiUrl,
        headers: config.headers,
        data: config.data,
    };
    var response = {
        code: code,
        msg: msg,
        data: data,
    };
    if (typeof apiLogConfig === "function") {
        response.data = apiLogConfig(data);
    }
    if (apiLogConfig === false) {
        response.data = "success";
    }
    return {
        response: response,
        request: request,
    };
}
function requestAfterLog(res) {
    try {
        var logData = getDataLog(res);
        return {
            v3: "ApiRequestInterceptor",
            msg: "接口响应",
            request: logData.request,
            response: logData.response,
        };
    }
    catch (e) {
        console.error(e);
        return {
            v3: "ApiRequestInterceptor",
            msg: "requestAfterLog:catch",
            request: e,
            response: "",
        };
    }
}
function generateResponseFormattedLog(data) {
    try {
        return {
            v3: "ApiRequestInterceptor",
            msg: "responseFormattedLog",
            request: data,
            response: {},
        };
    }
    catch (e) {
        console.error(e);
        return {
            v3: "ApiRequestInterceptor",
            msg: "responseFormattedLog:catch",
            request: e,
            response: "",
        };
    }
}

var excludeHeaders = [
    "head",
    "delete",
    "get",
    "options",
    "patch",
    "put",
    "post",
];
function generateRequestBeforeLogData(config) {
    try {
        var headers_1 = {};
        Object.keys(config.headers || {})
            .filter(function (header) { return excludeHeaders.indexOf(header) >= 0; })
            .forEach(function (header) {
            headers_1[header] = config.headers[header];
        });
        return {
            v3: "ApiRequestInterceptor",
            msg: "接口请求前",
            request: {
                url: config.url,
                data: config.data,
                params: config.params,
                headers: headers_1,
            },
        };
    }
    catch (e) {
        console.error(e);
        return {
            v3: "generateRequestBeforeLogData",
            msg: "catch",
            request: e,
        };
    }
}

/**
 * 格式化错误信息
 * @param error
 * @returns
 */
function responseErrorFormatter(error) {
    if (!error) {
        return Promise.reject({
            status: -1,
            code: null,
            msg: "网络异常，请稍后重试。",
            data: null,
            extra: { errMsg: "error参数不存在" },
        });
    }
    var apiLibError = ["NETWORK_ERROR", "TIMEOUT", "SCRIPT_ERROR"];
    if (apiLibError.includes(error.status) || Number(error.status) !== 200) {
        return Promise.reject({
            status: error.status,
            code: null,
            msg: "网络异常，请稍后重试。",
            data: null,
            extra: error.extra,
        });
    }
    return Promise.reject(error);
}

var AppletHttp = /** @class */ (function () {
    function AppletHttp() {
        this.apiKey = "";
        this.apiCode = "";
        this.getToken = null;
        this.beforeLog = null;
        this.afterOriginalLog = null;
        this.errorLog = null;
        this.afterLog = null;
        this.checkRetry = null;
    }
    /**
     * 添加签名数据
     * @param params 签名数据
     */
    AppletHttp.prototype.addSignOptions = function (params) {
        this.apiCode = params.apiCode;
        this.apiKey = params.apiKey;
    };
    /**
     * 添加获取token方法
     * @param getToken 获取token方法
     */
    AppletHttp.prototype.addTokenFunction = function (getToken) {
        if (typeof getToken !== "function") {
            throw new TypeError("getToken is not function");
        }
        this.getToken = getToken;
    };
    /**
     * 添加检测是否需要重新获取token的方法
     * @param executor 检测是否需要重新获取token的方法
     */
    AppletHttp.prototype.addCheckRetryExecutor = function (executor) {
        if (typeof executor !== "function") {
            throw new TypeError("executor param require function in addCheckRetryExecutor");
        }
        this.checkRetry = executor;
    };
    /**
     * 监听请求前的日志
     * @param {function} executor 获取请求前的日志
     * @returns
     */
    AppletHttp.prototype.beforeRequestLog = function (executor) {
        if (typeof executor !== "function") {
            throw new TypeError("executor param require function in beforeRequestLog");
        }
        this.beforeLog = executor;
    };
    /**
     * 监听响应的原始日志
     * @param executor 获取响应的原始日志
     */
    AppletHttp.prototype.afterResponseOriginalLog = function (executor) {
        if (typeof executor !== "function") {
            throw new TypeError("executor param require function in afterResponseOriginalLog");
        }
        this.afterOriginalLog = executor;
    };
    /**
     * 监听响应后格式化日志
     * @param executor 获取响应后格式化日志
     */
    AppletHttp.prototype.afterResponseLog = function (executor) {
        if (typeof executor !== "function") {
            throw new TypeError("executor param require function in afterResponseLog");
        }
        this.afterLog = executor;
    };
    /**
     * 监听错误日志
     * @param executor 获取错误日志
     */
    AppletHttp.prototype.addErrorLog = function (executor) {
        if (typeof executor !== "function") {
            throw new TypeError("executor param require function in addErrorLog");
        }
        this.errorLog = executor;
    };
    /**
     * 获取请求对象实例
     * @param options ICreateApiHttpOptions
     * @param reqConfig IAppletsRequestConfig
     */
    AppletHttp.prototype.getHttpIns = function (options, reqConfig) {
        var _this = this;
        var api = new ApiHttp({
            baseURL: options.baseURL,
            apiList: options.apiList,
        }, 
        // 设置所有的Content-Type为"application/json; charset=utf-8"
        reqConfig || {
            headers: {
                "Content-Type": "application/json; charset=utf-8",
            },
        });
        api.appletsRequest.defaults.timeout = 10000;
        // 添加签名拦截器
        api.addRequestInterceptor(function (config) {
            if (config.apiConfig.skipSign === false) {
                return config;
            }
            if (!_this.apiKey || !_this.apiCode) {
                console.warn("请使用addSignOptions(params)添加appKey和appCode");
                return config;
            }
            var interceptor = signInterceptor(_this.apiKey, _this.apiCode);
            return interceptor(config);
        });
        // 添加获取token拦截器
        api.addRequestInterceptor(function (config) { return __awaiter(_this, void 0, void 0, function () {
            var interceptor, intercept;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (config.apiConfig.requireToken === false) {
                            return [2 /*return*/, config];
                        }
                        if (!this.getToken) {
                            console.warn("请使用addTokenFunction(getToken)添加获取token接口");
                            return [2 /*return*/, config];
                        }
                        interceptor = getTokenRequestInterceptor(
                        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                        this.getToken);
                        return [4 /*yield*/, interceptor(config)];
                    case 1:
                        intercept = _a.sent();
                        return [2 /*return*/, intercept];
                }
            });
        }); });
        // 添加请求前日志
        api.addRequestInterceptor(function (config) {
            if (!_this.beforeLog || typeof _this.beforeLog !== "function") {
                return config;
            }
            var logInfo = generateRequestBeforeLogData(config);
            // logInfo = {
            //   v3: "",
            //   msg: "",
            //   request: string or object
            // }
            // 生成的logInfo可用于投递到日志系统中
            try {
                _this.beforeLog(logInfo);
            }
            catch (e) {
                console.error("beforeLog: ", e);
            }
            return config;
        });
        /**
         * 记录请求返回日志
         */
        api.addResponseInterceptor(function (res) {
            var _a;
            var logInfo = requestAfterLog(res);
            if (!_this.afterOriginalLog ||
                typeof _this.afterOriginalLog !== "function") {
                return res;
            }
            // logInfo = {
            //   v3: "",
            //   msg: "",
            //   request: string or object,
            //   response: string or object,
            // }
            // 可以使用logInfo，投递到日志系统
            try {
                _this.afterOriginalLog(logInfo, ((_a = res === null || res === void 0 ? void 0 : res.config) === null || _a === void 0 ? void 0 : _a.apiConfig) || {});
            }
            catch (e) {
                console.error("afterOriginalLog: ", e);
            }
            return res;
        });
        // 添加更新token拦截器
        api.addResponseInterceptor(function (res) {
            if (!_this.apiCode ||
                !_this.apiKey ||
                typeof _this.checkRetry !== "function" ||
                typeof _this.getToken !== "function") {
                return res;
            }
            var isRetry = _this.checkRetry(res);
            if (typeof isRetry !== "boolean" || !isRetry) {
                return res;
            }
            var interceptor = refreshTokenResponseInterceptor(
            // 需要更新token的错误码
            isRetry, 
            // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
            _this.getToken);
            return interceptor(res);
        });
        // 格式化输出请求返回数据
        api.addResponseInterceptor(responseFormatter);
        /**
         * 记录请求返回错误日志
         */
        api.addResponseInterceptor(function (res) {
            if (!_this.afterLog || typeof _this.afterLog !== "function") {
                return res;
            }
            var logInfo = generateResponseFormattedLog(res);
            // logInfo = {
            //   v3: "",
            //   msg: "",
            //   request: string or object,
            //   response: string or object,
            // }
            // 可以使用logInfo，投递到日志系统
            try {
                _this.afterLog(logInfo);
            }
            catch (e) {
                console.error("afterLog: ", e);
            }
            return res;
        }, function (err) {
            if (!_this.errorLog || typeof _this.errorLog !== "function") {
                return Promise.reject(err);
            }
            var logInfo = errorLog(err);
            // logInfo = {
            //   v3: "",
            //   msg: "",
            //   request: string or object,
            //   response: string or object,
            // }
            // 可以使用logInfo，投递到日志系统
            try {
                _this.errorLog(logInfo);
            }
            catch (e) {
                console.error("errorLog: ", e);
            }
            return Promise.reject(err);
        });
        /**
         * 格式化错误信息
         */
        api.addResponseInterceptor(function (res) { return res; }, responseErrorFormatter);
        return api;
    };
    return AppletHttp;
}());
var ins = new AppletHttp();

function signInterceptor(appKey, appCode) {
    return function interceptor(config) {
        var signData = {};
        Object.keys(config.data || {}).forEach(function (item) {
            var val = config.data[item];
            if (val !== null && typeof val !== "undefined") {
                signData[item] = val;
            }
        });
        config.headers["Authorization-AppKey"] = appKey;
        config.headers["Authorization-Sign"] = sha256()
            .update("" + appKey + JSON.stringify(signData) + (config.headers["Authorization-Token"] || "") + appCode)
            .digest("hex");
        if (config.data === null || typeof config.data === "undefined") {
            config.data = {};
        }
        return config;
    };
}
function getTokenRequestInterceptor(getToken, options) {
    return function getTokenInterceptor(config) {
        return __awaiter(this, void 0, void 0, function () {
            var data, err_1, errMsg, status_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, getToken(options || {})];
                    case 1:
                        data = (_a.sent()).data;
                        if (data.token === null || typeof data.token === "undefined") {
                            throw new TypeError("获取token失败");
                        }
                        config.headers["Authorization-Token"] = data.token;
                        config.tokenInterceptData = data;
                        return [2 /*return*/, config];
                    case 2:
                        err_1 = _a.sent();
                        errMsg = err_1.errMsg;
                        status_1 = err_1.status;
                        if (err_1 instanceof TypeError) {
                            errMsg = err_1.toString();
                            status_1 = "SCRIPT_ERROR";
                        }
                        return [2 /*return*/, Promise.reject({
                                status: status_1,
                                errMsg: errMsg,
                                config: config,
                                headers: err_1.headers || {},
                                data: {
                                    retcode: err_1.retcode,
                                    data: err_1.data,
                                    msg: err_1.msg,
                                },
                                response: null,
                                extra: null,
                            })];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
}
function refreshTokenResponseInterceptor(isRefresh, getToken) {
    return function refreshTokenInterceptor(res) {
        return __awaiter(this, void 0, void 0, function () {
            var data, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!isRefresh) return [3 /*break*/, 4];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, getToken({
                                isRefresh: true,
                            })];
                    case 2:
                        data = (_a.sent()).data;
                        return [2 /*return*/, Promise.reject(__assign({ errCode: "RETRY_ERROR", 
                                /**
                                 * 需要合并到request中的数据
                                 */
                                retryOptions: {
                                    headers: {
                                        "Authorization-Token": data.token,
                                    },
                                } }, (res || {})))];
                    case 3:
                        err_2 = _a.sent();
                        return [2 /*return*/, Promise.reject({
                                status: err_2.status,
                                errMsg: err_2.errMsg,
                                config: null,
                                headers: err_2.headers || {},
                                data: {
                                    retcode: err_2.retcode,
                                    data: err_2.data,
                                    msg: err_2.msg,
                                },
                                response: res,
                                extra: null,
                            })];
                    case 4: return [2 /*return*/, res];
                }
            });
        });
    };
}

export { AppletHttp, ins as appletHttp, errorLog as generateErrorLog, requestAfterLog as generateRequestAfterLog, generateRequestBeforeLogData as generateRequestBeforeLog, generateResponseFormattedLog, getTokenRequestInterceptor, refreshTokenResponseInterceptor, responseErrorFormatter as responseErrorFormatterInterceptor, responseFormatter as responseFormatterInterceptor, signInterceptor };
//# sourceMappingURL=api-interceptor.es.js.map
