"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.AppletHttp = void 0;
var applets_request_mode_list_1 = require("applets-request-mode-list");
var _1 = require(".");
var AppletHttp = /** @class */ (function () {
    function AppletHttp() {
        this.apiKey = "";
        this.apiCode = "";
        this.getToken = null;
        this.beforeLog = null;
        this.afterOriginalLog = null;
        this.errorLog = null;
        this.afterLog = null;
        this.checkRetry = null;
    }
    /**
     * 添加签名数据
     * @param params 签名数据
     */
    AppletHttp.prototype.addSignOptions = function (params) {
        this.apiCode = params.apiCode;
        this.apiKey = params.apiKey;
    };
    /**
     * 添加获取token方法
     * @param getToken 获取token方法
     */
    AppletHttp.prototype.addTokenFunction = function (getToken) {
        if (typeof getToken !== "function") {
            throw new TypeError("getToken is not function");
        }
        this.getToken = getToken;
    };
    /**
     * 添加检测是否需要重新获取token的方法
     * @param executor 检测是否需要重新获取token的方法
     */
    AppletHttp.prototype.addCheckRetryExecutor = function (executor) {
        if (typeof executor !== "function") {
            throw new TypeError("executor param require function in addCheckRetryExecutor");
        }
        this.checkRetry = executor;
    };
    /**
     * 监听请求前的日志
     * @param {function} executor 获取请求前的日志
     * @returns
     */
    AppletHttp.prototype.beforeRequestLog = function (executor) {
        if (typeof executor !== "function") {
            throw new TypeError("executor param require function in beforeRequestLog");
        }
        this.beforeLog = executor;
    };
    /**
     * 监听响应的原始日志
     * @param executor 获取响应的原始日志
     */
    AppletHttp.prototype.afterResponseOriginalLog = function (executor) {
        if (typeof executor !== "function") {
            throw new TypeError("executor param require function in afterResponseOriginalLog");
        }
        this.afterOriginalLog = executor;
    };
    /**
     * 监听响应后格式化日志
     * @param executor 获取响应后格式化日志
     */
    AppletHttp.prototype.afterResponseLog = function (executor) {
        if (typeof executor !== "function") {
            throw new TypeError("executor param require function in afterResponseLog");
        }
        this.afterLog = executor;
    };
    /**
     * 监听错误日志
     * @param executor 获取错误日志
     */
    AppletHttp.prototype.addErrorLog = function (executor) {
        if (typeof executor !== "function") {
            throw new TypeError("executor param require function in addErrorLog");
        }
        this.errorLog = executor;
    };
    /**
     * 获取请求对象实例
     * @param options ICreateApiHttpOptions
     * @param reqConfig IAppletsRequestConfig
     */
    AppletHttp.prototype.getHttpIns = function (options, reqConfig) {
        var _this = this;
        var api = new applets_request_mode_list_1.default({
            baseURL: options.baseURL,
            apiList: options.apiList,
        }, 
        // 设置所有的Content-Type为"application/json; charset=utf-8"
        reqConfig || {
            headers: {
                "Content-Type": "application/json; charset=utf-8",
            },
        });
        api.appletsRequest.defaults.timeout = 10000;
        // 添加签名拦截器
        api.addRequestInterceptor(function (config) {
            if (config.apiConfig.skipSign === false) {
                return config;
            }
            if (!_this.apiKey || !_this.apiCode) {
                console.warn("请使用addSignOptions(params)添加appKey和appCode");
                return config;
            }
            var interceptor = _1.signInterceptor(_this.apiKey, _this.apiCode);
            return interceptor(config);
        });
        // 添加获取token拦截器
        api.addRequestInterceptor(function (config) { return __awaiter(_this, void 0, void 0, function () {
            var interceptor, intercept;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (config.apiConfig.requireToken === false) {
                            return [2 /*return*/, config];
                        }
                        if (!this.getToken) {
                            console.warn("请使用addTokenFunction(getToken)添加获取token接口");
                            return [2 /*return*/, config];
                        }
                        interceptor = _1.getTokenRequestInterceptor(
                        // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
                        this.getToken);
                        return [4 /*yield*/, interceptor(config)];
                    case 1:
                        intercept = _a.sent();
                        return [2 /*return*/, intercept];
                }
            });
        }); });
        // 添加请求前日志
        api.addRequestInterceptor(function (config) {
            if (!_this.beforeLog || typeof _this.beforeLog !== "function") {
                return config;
            }
            var logInfo = _1.generateRequestBeforeLog(config);
            // logInfo = {
            //   v3: "",
            //   msg: "",
            //   request: string or object
            // }
            // 生成的logInfo可用于投递到日志系统中
            try {
                _this.beforeLog(logInfo);
            }
            catch (e) {
                console.error("beforeLog: ", e);
            }
            return config;
        });
        /**
         * 记录请求返回日志
         */
        api.addResponseInterceptor(function (res) {
            var _a;
            var logInfo = _1.generateRequestAfterLog(res);
            if (!_this.afterOriginalLog ||
                typeof _this.afterOriginalLog !== "function") {
                return res;
            }
            // logInfo = {
            //   v3: "",
            //   msg: "",
            //   request: string or object,
            //   response: string or object,
            // }
            // 可以使用logInfo，投递到日志系统
            try {
                _this.afterOriginalLog(logInfo, ((_a = res === null || res === void 0 ? void 0 : res.config) === null || _a === void 0 ? void 0 : _a.apiConfig) || {});
            }
            catch (e) {
                console.error("afterOriginalLog: ", e);
            }
            return res;
        });
        // 添加更新token拦截器
        api.addResponseInterceptor(function (res) {
            if (!_this.apiCode ||
                !_this.apiKey ||
                typeof _this.checkRetry !== "function" ||
                typeof _this.getToken !== "function") {
                return res;
            }
            var isRetry = _this.checkRetry(res);
            if (typeof isRetry !== "boolean" || !isRetry) {
                return res;
            }
            var interceptor = _1.refreshTokenResponseInterceptor(
            // 需要更新token的错误码
            isRetry, 
            // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
            _this.getToken);
            return interceptor(res);
        });
        // 格式化输出请求返回数据
        api.addResponseInterceptor(_1.responseFormatterInterceptor);
        /**
         * 记录请求返回错误日志
         */
        api.addResponseInterceptor(function (res) {
            if (!_this.afterLog || typeof _this.afterLog !== "function") {
                return res;
            }
            var logInfo = _1.generateResponseFormattedLog(res);
            // logInfo = {
            //   v3: "",
            //   msg: "",
            //   request: string or object,
            //   response: string or object,
            // }
            // 可以使用logInfo，投递到日志系统
            try {
                _this.afterLog(logInfo);
            }
            catch (e) {
                console.error("afterLog: ", e);
            }
            return res;
        }, function (err) {
            if (!_this.errorLog || typeof _this.errorLog !== "function") {
                return Promise.reject(err);
            }
            var logInfo = _1.generateErrorLog(err);
            // logInfo = {
            //   v3: "",
            //   msg: "",
            //   request: string or object,
            //   response: string or object,
            // }
            // 可以使用logInfo，投递到日志系统
            try {
                _this.errorLog(logInfo);
            }
            catch (e) {
                console.error("errorLog: ", e);
            }
            return Promise.reject(err);
        });
        /**
         * 格式化错误信息
         */
        api.addResponseInterceptor(function (res) { return res; }, _1.responseErrorFormatterInterceptor);
        return api;
    };
    return AppletHttp;
}());
exports.AppletHttp = AppletHttp;
var ins = new AppletHttp();
exports.default = ins;
//# sourceMappingURL=AppletHttp.js.map