"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.refreshTokenResponseInterceptor = exports.getTokenRequestInterceptor = exports.signInterceptor = exports.generateResponseFormattedLog = exports.generateRequestBeforeLog = exports.generateRequestAfterLog = exports.generateErrorLog = exports.responseErrorFormatterInterceptor = exports.responseFormatterInterceptor = exports.AppletHttp = exports.appletHttp = void 0;
var hash_js_1 = require("hash.js");
var responseFormatter_1 = require("./interceptors/responseFormatter");
exports.responseFormatterInterceptor = responseFormatter_1.default;
var errorLog_1 = require("./interceptors/errorLog");
exports.generateErrorLog = errorLog_1.default;
var requestAfterLog_1 = require("./interceptors/requestAfterLog");
exports.generateRequestAfterLog = requestAfterLog_1.default;
Object.defineProperty(exports, "generateResponseFormattedLog", { enumerable: true, get: function () { return requestAfterLog_1.generateResponseFormattedLog; } });
var requestBeforeLog_1 = require("./interceptors/requestBeforeLog");
exports.generateRequestBeforeLog = requestBeforeLog_1.default;
var responseErrorFormatter_1 = require("./interceptors/responseErrorFormatter");
exports.responseErrorFormatterInterceptor = responseErrorFormatter_1.default;
var AppletHttp_1 = require("./AppletHttp");
exports.appletHttp = AppletHttp_1.default;
Object.defineProperty(exports, "AppletHttp", { enumerable: true, get: function () { return AppletHttp_1.AppletHttp; } });
function signInterceptor(appKey, appCode) {
    return function interceptor(config) {
        var signData = {};
        Object.keys(config.data || {}).forEach(function (item) {
            var val = config.data[item];
            if (val !== null && typeof val !== "undefined") {
                signData[item] = val;
            }
        });
        config.headers["Authorization-AppKey"] = appKey;
        config.headers["Authorization-Sign"] = hash_js_1.sha256()
            .update("" + appKey + JSON.stringify(signData) + (config.headers["Authorization-Token"] || "") + appCode)
            .digest("hex");
        if (config.data === null || typeof config.data === "undefined") {
            config.data = {};
        }
        return config;
    };
}
exports.signInterceptor = signInterceptor;
function getTokenRequestInterceptor(getToken, options) {
    return function getTokenInterceptor(config) {
        return __awaiter(this, void 0, void 0, function () {
            var data, err_1, errMsg, status_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, getToken(options || {})];
                    case 1:
                        data = (_a.sent()).data;
                        if (data.token === null || typeof data.token === "undefined") {
                            throw new TypeError("获取token失败");
                        }
                        config.headers["Authorization-Token"] = data.token;
                        config.tokenInterceptData = data;
                        return [2 /*return*/, config];
                    case 2:
                        err_1 = _a.sent();
                        errMsg = err_1.errMsg;
                        status_1 = err_1.status;
                        if (err_1 instanceof TypeError) {
                            errMsg = err_1.toString();
                            status_1 = "SCRIPT_ERROR";
                        }
                        return [2 /*return*/, Promise.reject({
                                status: status_1,
                                errMsg: errMsg,
                                config: config,
                                headers: err_1.headers || {},
                                data: {
                                    retcode: err_1.retcode,
                                    data: err_1.data,
                                    msg: err_1.msg,
                                },
                                response: null,
                                extra: null,
                            })];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
}
exports.getTokenRequestInterceptor = getTokenRequestInterceptor;
function refreshTokenResponseInterceptor(isRefresh, getToken) {
    return function refreshTokenInterceptor(res) {
        return __awaiter(this, void 0, void 0, function () {
            var data, err_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (!isRefresh) return [3 /*break*/, 4];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, getToken({
                                isRefresh: true,
                            })];
                    case 2:
                        data = (_a.sent()).data;
                        return [2 /*return*/, Promise.reject(__assign({ errCode: "RETRY_ERROR", 
                                /**
                                 * 需要合并到request中的数据
                                 */
                                retryOptions: {
                                    headers: {
                                        "Authorization-Token": data.token,
                                    },
                                } }, (res || {})))];
                    case 3:
                        err_2 = _a.sent();
                        return [2 /*return*/, Promise.reject({
                                status: err_2.status,
                                errMsg: err_2.errMsg,
                                config: null,
                                headers: err_2.headers || {},
                                data: {
                                    retcode: err_2.retcode,
                                    data: err_2.data,
                                    msg: err_2.msg,
                                },
                                response: res,
                                extra: null,
                            })];
                    case 4: return [2 /*return*/, res];
                }
            });
        });
    };
}
exports.refreshTokenResponseInterceptor = refreshTokenResponseInterceptor;
//# sourceMappingURL=index.js.map