"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateResponseFormattedLog = void 0;
var lodash_get_1 = require("lodash.get");
/**
 * 组装接口响应日志
 * @param res
 * @returns
 */
function getDataLog(res) {
    var config = lodash_get_1.default(res, "config", {});
    var apiConfig = lodash_get_1.default(res, "config.apiConfig", {});
    var apiLogConfig = lodash_get_1.default(res, "config.apiConfig.log", true);
    var data = lodash_get_1.default(res, "data.data", "empty");
    var msg = lodash_get_1.default(res, "data.msg", "");
    var code = lodash_get_1.default(res, "data.code", -1);
    var request = {
        url: apiConfig.apiUrl,
        headers: config.headers,
        data: config.data,
    };
    var response = {
        code: code,
        msg: msg,
        data: data,
    };
    if (typeof apiLogConfig === "function") {
        response.data = apiLogConfig(data);
    }
    if (apiLogConfig === false) {
        response.data = "success";
    }
    return {
        response: response,
        request: request,
    };
}
function requestAfterLog(res) {
    try {
        var logData = getDataLog(res);
        return {
            v3: "ApiRequestInterceptor",
            msg: "接口响应",
            request: logData.request,
            response: logData.response,
        };
    }
    catch (e) {
        console.error(e);
        return {
            v3: "ApiRequestInterceptor",
            msg: "requestAfterLog:catch",
            request: e,
            response: "",
        };
    }
}
exports.default = requestAfterLog;
function generateResponseFormattedLog(data) {
    try {
        return {
            v3: "ApiRequestInterceptor",
            msg: "responseFormattedLog",
            request: data,
            response: {},
        };
    }
    catch (e) {
        console.error(e);
        return {
            v3: "ApiRequestInterceptor",
            msg: "responseFormattedLog:catch",
            request: e,
            response: "",
        };
    }
}
exports.generateResponseFormattedLog = generateResponseFormattedLog;
//# sourceMappingURL=requestAfterLog.js.map