"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var excludeHeaders = [
    "head",
    "delete",
    "get",
    "options",
    "patch",
    "put",
    "post",
];
function generateRequestBeforeLogData(config) {
    try {
        var headers_1 = {};
        Object.keys(config.headers || {})
            .filter(function (header) { return excludeHeaders.indexOf(header) >= 0; })
            .forEach(function (header) {
            headers_1[header] = config.headers[header];
        });
        return {
            v3: "ApiRequestInterceptor",
            msg: "接口请求前",
            request: {
                url: config.url,
                data: config.data,
                params: config.params,
                headers: headers_1,
            },
        };
    }
    catch (e) {
        console.error(e);
        return {
            v3: "generateRequestBeforeLogData",
            msg: "catch",
            request: e,
        };
    }
}
exports.default = generateRequestBeforeLogData;
//# sourceMappingURL=requestBeforeLog.js.map