"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * 格式化错误信息
 * @param error
 * @returns
 */
function responseErrorFormatter(error) {
    if (!error) {
        return Promise.reject({
            status: -1,
            code: null,
            msg: "网络异常，请稍后重试。",
            data: null,
            extra: { errMsg: "error参数不存在" },
        });
    }
    var apiLibError = ["NETWORK_ERROR", "TIMEOUT", "SCRIPT_ERROR"];
    if (apiLibError.includes(error.status) || Number(error.status) !== 200) {
        return Promise.reject({
            status: error.status,
            code: null,
            msg: "网络异常，请稍后重试。",
            data: null,
            extra: error.extra,
        });
    }
    return Promise.reject(error);
}
exports.default = responseErrorFormatter;
//# sourceMappingURL=responseErrorFormatter.js.map